#----------------------------------------------------------------------------------------
# array-2d-erzeugen.py
#----------------------------------------------------------------------------------------
# Erzeuge ein 2-dimensionalen Arrays mit z Zeilen und s Spalten. 
# z und s werden von der Kommandozeile gelesen.
# In Zeile i und Spalte j soll das Array Eintrag 'i,j' haben.
#----------------------------------------------------------------------------------------
import sys

z = int(sys.argv[1])
s = int(sys.argv[2])

# Variante 1:  -------------------------------------------------------------------------
# Es soll Array b erzeugt werden.
# Zuerst besteht b aus z Elementen, die die Zeilen werden sollen.
# Für jede Zeile von b wird nun ein Array mit s Elementen erzeugt und gefüllt.

b = [0]*z                      # erzeuge Array b mit z Plätzen für die Zeilen
for zeilennr in range(z):
  b[zeilennr] = [0]*s             # erzeuge ein Array als z-te Zeile von b
  for spaltennr in range(s):      # fülle jeden Eintrag in der z-ten Zeile von b
     b[zeilennr][spaltennr] = str(zeilennr) + ',' + str(spaltennr)

print('b: ' + str(b))

# Variante 2:  -------------------------------------------------------------------------
# Es soll Array c erzeugt werden.
# Zuerst ist c das leere Array.
# Anschließend werden alle Zeilen von c erzeugt und an c angehängt.
# Jede Zeile von c wird aus einem leeren Array erzeugt. 

c = []                         # erzeuge leeres Array c
for zeilennr in range(z):
  d = []                       # erzeuge die nächste Zeile von c; zu Beginn ist sie leer
  for spaltennr in range(s):      # hänge die Elemente von d der Reihe nach an d an
     d += [str(zeilennr) + ',' + str(spaltennr)]
  c += [d]                     # hänge die neu erzeugte Zeile d von c an c an

print('c: ' + str(c))

#----------------------------------------------------------------------------------------
# python3 array-2d-erzeugen.py 2 3
# b: [['0,0', '0,1', '0,2'], ['1,0', '1,1', '1,2']]
# c: [['0,0', '0,1', '0,2'], ['1,0', '1,1', '1,2']]
#
# python3 array-2d-erzeugen.py 5 3
# b: [['0,0', '0,1', '0,2'], ['1,0', '1,1', '1,2'], ['2,0', '2,1', '2,2'], ['3,0', '3,1', '3,2'], ['4,0', '4,1', '4,2']]
# c: [['0,0', '0,1', '0,2'], ['1,0', '1,1', '1,2'], ['2,0', '2,1', '2,2'], ['3,0', '3,1', '3,2'], ['4,0', '4,1', '4,2']]






