# flaechefuellen.py
#------------------------------------------------------------------------------------------------------------
# Das Programm pflastert eine vorgegebene Fläche mit L-Steinen.
# Das Programm geht rein zufällig vor. 
# Die Stellen und die Steine, die darauf kommen sollen, werden zufällig gewählt.
#------------------------------------------------------------------------------------------------------------
import sys, random

# Lies die Breite und die Höhe der Fläche ein.
breite = int(sys.argv[1])
hoehe  = int(sys.argv[2])

# Erzeuge ein 2d-Array frei mit hoehe Zeilen und breite Spalten.
# Alle Einträge im Array sind True.
frei = [ True ] * hoehe
for i in range(len(frei)):
   frei[i] = [ True ] * breite

# Wiederhole oft (genug):
#    wähle zufällig eine Stelle [z][s] in der Fläche
#    wähle zufällig die Form eines L-Steins
#    falls die Stelle für den L-Stein frei ist, dann lege ihn dorthin
for i in range((breite*hoehe)**2):
  z,s = random.randrange(hoehe), random.randrange(breite)   # die Stelle in der Fläche
  form = random.randrange(4)                                # die Form des L-Steins
  # Lege den Stein der gewählten Form an die gewählte Stelle, wenn er passt.
  if form==0 and z+1<hoehe and s+1<breite and frei[z][s] and frei[z+1][s] and frei[z][s+1]:
          frei[z][s]   = False
          frei[z+1][s] = False
          frei[z][s+1] = False  
  if form==1 and z+1<hoehe and 0<=s-1 and frei[z][s] and frei[z+1][s] and frei[z][s-1]:
          frei[z][s] = frei[z+1][s] = frei[z][s-1] = False  
  if form==2 and 0<=z-1 and 0<=s-1 and frei[z][s] and frei[z-1][s] and frei[z][s-1]:
          frei[z][s] = frei[z-1][s] = frei[z][s-1] = False  
  if form==3 and 0<=z-1 and s+1<hoehe and frei[z][s] and frei[z-1][s] and frei[z][s+1]:
          frei[z][s] = frei[z+1][s] = frei[z][s+1] = False  

# Gib die belegten Stellen der Fläche und den Füllungsgrad aus.
belegteStellen = 0               # Zähler für die belegten Stellen.
for z in range(len(frei)):       # Die Fläche und ihre Belegung wird "zeilenweise" ausgegeben.
  for s in range(len(frei[z])):
    if frei[z][s]: print('*', end='')
    else:          print('X', end='') ; belegteStellen+=1
  print()

print('Füllungsgrad ', belegteStellen/(breite*hoehe))  # Der Füllungsgrad wird ausgegeben.

#------------------------------------------------------------------------------------------------------------
# python3 flaechefuellen.py 10 10
# XXX*XXX*XX
# XXXXXXXX*X
# XX*XXXXXX*
# XXXXXX*XX*
# XXXXXXXXXX
# X**XXXXXXX
# XXXXX*XX*X
# XXXXXXXXXX
# XX*XX*XXXX
# *XX*XX*XXX
# Füllungsgrad  0.84
#
# python3 flaechefuellen.py 20 20
# *XXXX**XXXXXXX*XXXX*
# XXXXXXXXXXXX*XXXXXXX
# X*X*XXX*XX*XX*XXXXXX
# XXXX*XXXXX*XXXXXXXXX
# XXXXX*XXXXXXX*X*XXXX
# XXXXXXXXX*XXXXXXXX*X
# XXX*X*XXXXXXXXXX*XX*
# XXXXXX*XXXXX*XXXXXXX
# XXXXXXXXX*X*XX*XX*XX
# XXXXXXXXX*X*XXXXXXXX
# XXXX**XXXXXX*XX*XXX*
# XXXXXXXX*XXX*XXXXXX*
# *XXXXXXXXXXXXX*XXXX*
# *XXXXXXX*X*XXXXXXXXX
# XXXXXX*XXXXXX*XX*XXX
# XXXXXXXX*XX*XXXX*XX*
# *XXXXXXXX**XXXX*XX*X
# *X*XXXXX*XXXXX*XX*XX
# XXXXXXXXXXXXXX*XXXXX
# XX**X*X****XXX*XXXXX
# Füllungsgrad  0.825

