# flaechefuellen_v2.py
#------------------------------------------------------------------------------------------------------------
# Das Programm pflastert eine vorgegebene Fläche mit L-Steinen.
# Das Programm geht rein zufällig vor. 
# Die Stellen und die Steine, die darauf kommen sollen, werden zufällig gewählt.
# Die Pflasterung wird so ausgegeben, dass man die verwendeten L-Stein an Zahlenwerten erkennen kann.
#------------------------------------------------------------------------------------------------------------
import sys, random

# Lies die Breite und die Höhe der Fläche ein.
breite = int(sys.argv[1])
hoehe  = int(sys.argv[2])

# Erzeuge ein 2d-Array frei mit hoehe Zeilen und breite Spalten.
# Alle Einträge im Array haben Wert -1 ( für "frei" ).
frei = [ -1 ] * hoehe
for i in range(len(frei)):
   frei[i] = [ -1 ] * breite

# Die Variable form enthält die 4 Formen von L-Steinen.
form = ( (1,1), (1,-1), (-1,1), (-1,-1) )

steinzaehler = 0        #  Zähler für die verlegten Pflastersteine.
# Wiederhole oft (genug):
#    wähle zufällig eine Stelle [z][s] in der Fläche
#    wähle zufällig die Form eines L-Steins
#    falls die Stelle für den L-Stein frei ist, dann lege ihn dorthin
for i in range((breite*hoehe)**2):
  z,s = random.randrange(hoehe), random.randrange(breite)   # die Stelle in der Fläche
  dz,ds = form[random.randrange(4)]                         # die Form des L-Steins
  if 0<=z+dz<hoehe and 0<=s+ds<breite:                      # wenn der L-Stein nicht über den Rand ragt
    if frei[z][s]==-1 and frei[z+dz][s]==-1 and frei[z][s+ds]==-1: #   und alle Stellen frei für ihn sind,
        frei[z][s] = frei[z+dz][s] = frei[z][s+ds] = steinzaehler  # dann lege ihn an die Stelle
        steinzaehler += 3                                  # Ein weiterer Stein wurde verlegt.

# Gib die belegten Stellen der Fläche und den Füllungsgrad aus.
for z in range(len(frei)):       # Die Fläche und ihre Belegung wird "zeilenweise" ausgegeben.
  for s in range(len(frei[z])):
    if frei[z][s]==-1: print('*', end='')
    else:              print(frei[z][s]%10, end='')
  print()

print('Füllungsgrad ', steinzaehler/(breite*hoehe))  # Der Füllungsgrad wird ausgegeben.

#------------------------------------------------------------------------------------------------------------
# python3 flaechefuellen_v3.py 10 10
# 22*3*66*77
# *233556277
# *611952277
# 66*199228*
# 114444288*
# 134*43555*
# 833*335550
# 88699*9900
# 06619*0988
# 0011*00*8*
# Füllungsgrad  0.84

